--- text_cursor.c	2002-09-03 04:59:49.000000000 -0400
+++ text_cursor.c	2014-12-27 01:46:49.000000000 -0500
@@ -61,4 +61,5 @@
 #include "page.h"
 #include "selection.h"
+#include "handle_key.h"
 
 FCT (static void, GetCurrentXY, (Text *text, int *x, int *y, char *c) );
@@ -250,7 +251,7 @@ int MoveToXYinTextWindow ( text, x, y )
     int x, y;
 {
-    char *s, *sh;
+    const char *s;
+    const char *sh;
     int i, cur_line, new_line, delta;
-    char *HscrollString ();
     int len;
     
@@ -517,15 +518,14 @@ static void GetCurrentXY ( text, x, y, c
     char *c;	/* RETURN */
 {
-    char *s;  /* Current line */
-    char *cl; /* Current line from left */
+    const char *s;  /* Current line */
+    const char *cl; /* Current line from left */
     int n, n0;
     int len, clipx;
     int nc_l;
-    char *HscrollString ();
-    
+
     if ( TextInBuf ( text ) == False ) {
 	*x = text -> x_or;
 	*y = text -> y_or;
-	*c = 0;
+	*c = '\0';
 	return;
     }
@@ -615,5 +615,5 @@ static void GetCurrentXY ( text, x, y, c
 int MyTextWidth ( text, str, i )
     Text *text;
-    char *str;
+    const char *str;
     int i;
 {
@@ -624,7 +624,6 @@ int MyTextWidth ( text, str, i )
     int sizetab = tab_width * text -> blanc_width;
     xx = x = width = 0;
-    p = s = str;
 
-    if ( str == 0 ) 
+    if (str == NULL) 
       (void) fprintf ( stderr, "Internal Error 3...\n" );
     
@@ -638,11 +637,6 @@ int MyTextWidth ( text, str, i )
     if ( count == 0 )
       return 0;
-    else if ( count > 1 ) {
-      pp = (char *) malloc ((unsigned) count + 1);
-      (void) bcopy ( str, pp, count );
-    }
-    else
-	pp = str;
-	  
+    pp = strdup(str);
+
     p = pp;
     s = pp;
@@ -653,5 +647,5 @@ int MyTextWidth ( text, str, i )
 	}
 	p++;
-	count --;
+	count--;
     }
     p = pp; /* Pour replacer p au debut de la chaine */
@@ -677,6 +671,5 @@ int MyTextWidth ( text, str, i )
     }
     x += XTextWidth ( text -> font, s, n - 1 );
-    if ( count > 1 )
-      (void) free (pp);
+    free (pp);
     return (x);
 }
@@ -691,6 +684,6 @@ int MyTextWidth ( text, str, i )
 **		a la tabulation souhaitee.
 */
-char *HscrollString ( s, text )
-    char *s;
+char *HscrollString (s, text)
+    const char *s;
     Text *text;
 {
@@ -714,5 +707,5 @@ char *HscrollString ( s, text )
 	d--;
     }
-    return s;
+    return (char *)s;
 }
 
--- text_cursor.h	1996-09-18 07:59:40.000000000 -0400
+++ text_cursor.h	2014-12-27 01:38:34.000000000 -0500
@@ -49,5 +49,5 @@ FCT (int, ForwardChar, (Text *text) );
 FCT (void, FreezeTextCursor, (Text *text) );
 FCT (void, GotoLeft, (Text *text) );
-FCT (char *, HscrollString, (char *s, Text *text) );
+FCT (char *, HscrollString, (const char *s, Text *text) );
 FCT (void, MoveToBline, (Text *text) );
 FCT (void, MoveToEline, (Text *text) );
@@ -57,5 +57,5 @@ FCT (void, TextCursorOff, (Text *text) )
 FCT (void, UnFreezeTextCursor, (Text *text) );
 FCT (void, UpCursor, (Text *text) );
-FCT (int, MyTextWidth, (Text *text,char *str, int i) );
+FCT (int, MyTextWidth, (Text *text, const char *str, int i) );
 
 #endif /* _TEXT_CURSOR_H_ */
--- tool_bar.c	2001-10-21 16:24:50.000000000 -0400
+++ tool_bar.c	2014-12-27 05:42:39.000000000 -0500
@@ -39,4 +39,5 @@
 
 #include <stdio.h>
+#include <stdlib.h>
 #include <X11/Xlib.h>
 #include <X11/Xutil.h>
@@ -65,4 +66,5 @@
 #include "buttons_bits.h"
 #include "browser_init.h"
+#include "tbox.h"
 
 extern Display *dpy;
@@ -91,5 +93,5 @@ void (*f_tb_window []) () = {
 };
 
-static unsigned char *bname [] = {
+static const char *bname [] = {
   "Open file",
   "New window",
@@ -114,5 +116,5 @@ static unsigned char *bname [] = {
 };
 
-static unsigned char *bitmap_name [] = {
+static const char *bitmap_name [] = {
   dired_bits,
   new_window_bits,
@@ -137,5 +139,5 @@ static unsigned char *bitmap_name [] = {
 };
 
-static unsigned char **xpm_name [] = {
+static const char **xpm_name [] = {
   xpm_dired_bits,
   xpm_new_window_bits,
@@ -223,5 +225,5 @@ void InitToolBar(bg, ts, bs)
   for (i=0;i<N_BTOOLS;i++) {
     if ((depth == 16)||(depth == 24)) {
-      b_image [i] = (XImage *)LoadImage256 ((char **)xpm_name [i]);
+      b_image [i] = LoadImage256 (xpm_name [i]);
       b_pix [i] = XCreatePixmap (dpy, root, 32, 32, depth);
       XPutImage (dpy, b_pix [i], tb_gc, b_image[i], 0, 0, 0, 0, 32, 32);
@@ -254,5 +256,5 @@ ToolBar *CreateToolBar(parent, x, y)
   XWindowAttributes att;
   
-  ToolBar *tb = (ToolBar *) malloc (sizeof(ToolBar)+2);
+  ToolBar *tb = malloc (sizeof(ToolBar)+2);
    
   depth = DefaultDepth ( dpy, DefaultScreen ( dpy ));
@@ -268,5 +270,5 @@ ToolBar *CreateToolBar(parent, x, y)
 			  BlackPixel(dpy, DefaultScreen(dpy)),
 			  WhitePixel(dpy, DefaultScreen(dpy)));
-    
+
     tb -> tw [i].f = f_tb_window[i];
     XSelectInput ( dpy, tb -> tw [i].w, ExposureMask | ButtonPressMask | ButtonReleaseMask  
@@ -292,9 +294,9 @@ ToolBar *CreateToolBar(parent, x, y)
 
   if ((depth == 16)||(depth == 24)) {
-    logo_image = (XImage *)LoadImage256 ((char **)xpm_logo);
+    logo_image = LoadImage256 (xpm_logo);
     logo_pixmap = XCreatePixmap (dpy, root, 32, 32, depth);
     /* Le mask */
     logo_mask = XCreatePixmapFromBitmapData ( dpy, root, 
-				   logo_bits,
+				   (char *)logo_bits,
 				   TOOL_WINDOW_SIZE,
 				   TOOL_WINDOW_SIZE, 
@@ -307,5 +309,5 @@ ToolBar *CreateToolBar(parent, x, y)
   logo_pix = XCreatePixmapFromBitmapData ( dpy, root, 
 				   /* xlogo32_bits, */
-					  bwlogo_bits,
+				   (char *)bwlogo_bits,
 				   TOOL_WINDOW_SIZE,
 				   TOOL_WINDOW_SIZE, 
@@ -314,5 +316,5 @@ ToolBar *CreateToolBar(parent, x, y)
  
   slogo_pix = XCreatePixmapFromBitmapData ( dpy, root,
-					   slogo_bits,
+					   (char *)slogo_bits,
 					   40, 8,
 					   BlackPixel(dpy, DefaultScreen(dpy)),
--- tool_bar.h	2001-08-15 09:23:37.000000000 -0400
+++ tool_bar.h	2014-12-27 05:45:04.000000000 -0500
@@ -51,5 +51,5 @@ typedef struct _btool_window {
         void    (* f) ();
 	Pixmap pix;
-	char *title;
+	const char *title;
 }tool_window;
 
@@ -60,4 +60,5 @@ typedef struct _ToolBar {
 } ToolBar;
 
+struct EdWin;
 
 FCT (ToolBar *, CreateToolBar, (Window parent, int x, int y) );
@@ -65,4 +66,6 @@ FCT (void, DisplayToolBar, (ToolBar *too
 FCT (int, ExposeToolBar, (ToolBar *tool_bar, XEvent *ev) );
 FCT (void, InitToolBar, (unsigned long bg, unsigned long ts, unsigned long bs) );
+FCT (int, EnterInToolBar, (struct EdWin *, Window) );
+FCT (int, ToolBarButton, (struct EdWin *, XEvent *) );
 
 #endif /* _TOOLS_BAR_H_ */
--- undo.c	2001-06-18 07:09:31.000000000 -0400
+++ undo.c	2014-12-27 01:34:33.000000000 -0500
@@ -5,5 +5,5 @@
    File: undo.c
    Path: /home/fournigault/c/X11/xcoral-2.31/undo.c
-   Description: 
+   Description:
    Created: Fri Jan 27 11:38:09 MET 1995
    Author: Lionel Fournigault
@@ -12,9 +12,9 @@
 
    RCS $Revision$ $State$
-   
+
 
    ########################################################################
 
-   Note: 
+   Note:
 
    ########################################################################
@@ -73,8 +73,8 @@ FCT (static void, Do_UDelOneChar, (Text 
 FCT (static void, Do_UReplace, (Text *text,int type, int old_line, int old_pos) );
 FCT (static Undo *, GetCurrentUndo, (Text *text) );
-FCT (static void, U_AddChars, (Text *text, int type, char *s, int len, int n) );
-FCT (static void, U_DelChars, (Text *text, char *s, int len) );
-FCT (static void, U_OneChar, (Text *text, int len, char *s, char *sr, int type) );
-FCT (static void, U_RepAlloc, (char **p, char *str) );
+FCT (static void, U_AddChars, (Text *text, int type, const char *s, int len, int n) );
+FCT (static void, U_DelChars, (Text *text, const char *s, int len) );
+FCT (static void, U_OneChar, (Text *text, int len, const char *s, const char *sr, int type) );
+FCT (static void, U_RepAlloc, (char **p, const char *str) );
 
 static int flag_redo = 0;
@@ -84,10 +84,4 @@ extern Display *dpy;
 /* #define U_TRACE */
 
-FCT (void, DeleteUndo, (Text *text));
-FCT (void, ResetUndo, (Text *text));
-FCT (void, StoreInUndo, (Text *text, char *s, char *sr, int len, int n, int type));
-FCT (void, DoUndo, (Text *text));
-FCT (void, DoUndoUndo, (Text *text));
-
 /*
 **	Pour le buffer courant, les infos seront stokees dans
@@ -110,5 +104,5 @@ static Undo *GetCurrentUndo ( text )
     int index = 0;
     Undo *tmp = text -> udi;
-    
+
     while ( index != text -> u_index ) {
 	tmp = tmp -> next;
@@ -141,5 +135,5 @@ void DeleteUndo ( text )
     int i =0;
 #endif /* U_TRACE */
-    
+
     if ( current_u == 0 ) {
 #ifdef U_TRACE
@@ -148,9 +142,9 @@ void DeleteUndo ( text )
 	return;
     }
-    
+
     while ( True ) {
 	if ( current_u -> buf  != 0 ) {
 #ifdef U_TRACE
-	    (void) fprintf ( stderr, "DeleteUndo : free (buf) %d\n",  
+	    (void) fprintf ( stderr, "DeleteUndo : free (buf) %d\n",
 			    current_u -> buf );
 #endif /* U_TRACE */
@@ -166,5 +160,5 @@ void DeleteUndo ( text )
 	if ( current_u -> str_new != 0 ) {
 #ifdef U_TRACE
-	    (void) fprintf ( stderr, "DeleteUndo : free (str_new) %d\n", 
+	    (void) fprintf ( stderr, "DeleteUndo : free (str_new) %d\n",
 			    current_u -> str_new );
 #endif /* U_TRACE */
@@ -175,5 +169,5 @@ void DeleteUndo ( text )
 	    (void) fprintf ( stderr, "DeleteUndo : free (end) %d\n",  current_u );
 #endif /* U_TRACE */
-	    (void) free ( (char *) current_u );		
+	    (void) free ( (char *) current_u );
 #ifdef U_TRACE
 	    i++;
@@ -193,5 +187,5 @@ void DeleteUndo ( text )
     (void) fprintf ( stderr, "DeleteUndo : free %d undo elements %d\n", i );
 #endif /* U_TRACE */
-    
+
 }
 
@@ -200,5 +194,5 @@ void DeleteUndo ( text )
 **
 **	Description : Alloue une structure Undo et mise a zero
-**	Input : 
+**	Input :
 **	Ouput : Le pointeur sur la structure ou 0 si ya plus de memoire.
 */
@@ -206,13 +200,13 @@ static Undo *AllocUndoBuf ()
 {
     Undo *tmp;
-    
+
     if (( tmp = (Undo *) malloc ((unsigned) sizeof (Undo))) == 0 )
       return 0;
-    
+
     bzero ( (char *) tmp, sizeof (Undo));
 #ifdef U_TRACE
     (void) fprintf ( stderr, "AllocUndoBuf : %d\n", tmp );
 #endif /* U_TRACE */
-    
+
     return (tmp);
 }
@@ -222,5 +216,5 @@ static Undo *AllocUndoBuf ()
 **
 **	Description : Mise a zero de la liste.
-**		
+**
 **	Input : 	Le Text courant
 **	Ouput :
@@ -235,7 +229,7 @@ void ResetUndo ( text )
 	return;
     }
-    
+
     DeleteUndo ( text );
-    
+
     text -> udi = 0;
     text -> u_index = 0;
@@ -251,5 +245,5 @@ void ResetUndo ( text )
 **		passe dans cette fonction.
 **
-**	Input : 
+**	Input :
 **		Le Text courant,
 **		La chaine ajoutee ou enlevee,
@@ -258,10 +252,10 @@ void ResetUndo ( text )
 **		Le nombre de lignes dans la chaine,
 **		Le type de l'operation.
-**		
+**
 **	Ouput :
 */
 void StoreInUndo ( text, s, sr, len ,n, type )
     Text *text;
-    char *s, *sr;
+    const char *s, *sr;
     int len;
     int n;
@@ -269,9 +263,9 @@ void StoreInUndo ( text, s, sr, len ,n, 
 {
     Undo *new_udi;
-    
-    if ( text -> shell_id != 0 ) 
+
+    if ( text -> shell_id != 0 )
       return;
-    
-    if ( s == 0 ) {
+
+    if (s == NULL) {
 #ifdef U_TRACE
 	(void) fprintf ( stderr, "StoreInUndo : (null) string\n" );
@@ -279,5 +273,5 @@ void StoreInUndo ( text, s, sr, len ,n, 
 	return;
     }
-    
+
     /*
        * Si des 'undo' ont ete effectues, alors on les vire.
@@ -285,8 +279,8 @@ void StoreInUndo ( text, s, sr, len ,n, 
     if ( text -> u_index != 0 )
       CompactUndo ( text );
-    
-    if ( (new_udi = AllocUndoBuf ()) == 0 ) 
+
+    if ( (new_udi = AllocUndoBuf ()) == 0 )
       (void) fprintf ( stderr, "Hum... AllocUndoBuf memory error\n" );
-    
+
     if ( text -> udi != 0 ) {
 #ifdef U_TRACE
@@ -297,19 +291,19 @@ void StoreInUndo ( text, s, sr, len ,n, 
     }
     text -> udi = new_udi;
-    
+
     if ( len == 1 || len == -1 ) {
-	/* 
-	   * on ajoute ou on enleve 1 seul caractere 
+	/*
+	   * on ajoute ou on enleve 1 seul caractere
 	   * si sr != 0 alors c'est une substitution.
 	*/
 	(void) U_OneChar ( text, len, s, sr, type );
     }
-    
-    else { 			
+
+    else {
 	if ( len > 0 ) {
 	    /* On a ajoute plusieurs caracteres */
 	    (void) U_AddChars ( text, type, s, len, n );
 	}
-	else {	
+	else {
 	    /* on enleve plusieurs caracteres */
 	    (void ) U_DelChars ( text, s, len );
@@ -326,5 +320,5 @@ void StoreInUndo ( text, s, sr, len ,n, 
 **	Description : Plusieurs caracteres ont ete effaces.
 **		Avant de stoker les infos, on verifie si ya assez
-**		de place pour ranger les caracteres effaces. 	
+**		de place pour ranger les caracteres effaces.
 **
 **	Input : Le Text courant, la chaine effacee et sa longueur.
@@ -333,5 +327,5 @@ void StoreInUndo ( text, s, sr, len ,n, 
 static void U_DelChars (text, s, len )
     Text *text;
-    char *s;
+    const char *s;
     int len;
 {
@@ -339,5 +333,5 @@ static void U_DelChars (text, s, len )
     (void) fprintf ( stderr, "U_DelChars\n" );
 #endif /* U_TRACE */
-    
+
     if ( (- len ) > text -> udi -> size ) {
 #ifdef U_TRACE
@@ -359,7 +353,7 @@ static void U_DelChars (text, s, len )
     /*	(void) strncpy ( text -> udi -> buf, s, -len ); */
     (void) bcopy ( s, text -> udi -> buf, -len );
-    
+
     text -> udi -> buf [-len] = 0;
-    
+
     text -> udi -> pos = GetNcFromLeft ( text -> buf );
     text -> udi -> current_line = text -> no_current_line;
@@ -373,5 +367,5 @@ static void U_DelChars (text, s, len )
 **	Description : Plusieurs caracteres ont ete ajoutes.
 **		Avant de stocker les infos, on verifie si ya assez
-**		de place pour ranger les caracteres ajoutes. 	
+**		de place pour ranger les caracteres ajoutes.
 **
 **	Input : Le Text courant,
@@ -384,5 +378,5 @@ static void U_AddChars ( text,type, s, l
     Text *text;
     int type;
-    char *s;
+    const char *s;
     int len, n;
 {
@@ -437,5 +431,5 @@ static void U_AddChars ( text,type, s, l
 **	Description : Un caractere a ete ajoute ou enleve.
 **		On se sert aussi de cette fonction pour les
-**		substitutions (global ou query).			
+**		substitutions (global ou query).
 **
 **	Input : Le Text courant,
@@ -449,5 +443,5 @@ static void U_OneChar ( text, len, s, sr
     Text *text;
     int len;
-    char *s, *sr;
+    const char *s, *sr;
     int type;
 {
@@ -466,5 +460,5 @@ static void U_OneChar ( text, len, s, sr
 #endif /* U_TRACE */
       text -> udi -> c = *s;
-      text -> udi -> pos = 
+      text -> udi -> pos =
 	(len == 1) ? GetNcFromLeft ( text -> buf ) : 1+GetNcFromLeft ( text -> buf );
       text -> udi -> op = (len == 1) ? U_ADD : U_DEL;
@@ -487,5 +481,5 @@ static void U_OneChar ( text, len, s, sr
     }
     text -> udi -> current_line = text -> no_current_line;
-    text -> udi -> one_char = True; 
+    text -> udi -> one_char = True;
     text -> udi -> type = type;
     text -> udi -> nb_lines = 0;
@@ -503,8 +497,9 @@ static void U_OneChar ( text, len, s, sr
 */
 static void U_RepAlloc ( p, str )
-    char **p, *str;
+    char **p;
+    const char *str;
 {
     if ( *p == 0 ) {
-	*p = (char *) malloc ( (unsigned) strlen (str) + 1);
+	*p = malloc(strlen(str) + 1);
 #ifdef U_TRACE
 	(void) fprintf ( stderr, "U_RepAlloc : p (null) : malloc %d\n", *p );
@@ -544,5 +539,5 @@ static void CompactUndo ( text )
     (void) fprintf ( stderr, "CompactUndo from index %d\n", text -> u_index );
 #endif /* U_TRACE */
-    
+
     while ( text -> u_index != 0 ) {
 	if ( current_u -> buf  != 0 ) {
@@ -590,16 +585,16 @@ void DoUndo ( text )
     Mode *save_mode = text -> current_mode;
     Undo *tmp = GetCurrentUndo ( text );
-    
+
     if (text -> selection -> select == True)
       ClearSelection(text, True);
-    
+
     text -> current_mode = (Mode *) GetMode ("default");
 #ifdef U_TRACE
     (void) fprintf ( stderr, "DoUndo\n" );
 #endif /* U_TRACE */
-    
+
     old_pos = 	GetNcFromLeft ( text -> buf );
     old_line = text -> no_current_line;
-    
+
     if ( tmp == 0 ) {
 #ifdef U_TRACE
@@ -626,12 +621,12 @@ void DoUndo ( text )
 	MoveToBline ( text );
     }
-    
+
     if ( tmp -> one_char == True ) {
 	switch ( tmp -> type ) {
 	case U_STD:
 	case U_INSERT:
-	  if ( tmp -> op == U_ADD ) 
+	  if ( tmp -> op == U_ADD )
 	    (void) Do_UDelOneChar ( text );
-	  else 
+	  else
 	    (void) Do_UAddOneChar ( text );
 	  break;
@@ -645,5 +640,5 @@ void DoUndo ( text )
     }
     else {
-      if ( tmp -> op == U_ADD ) 
+      if ( tmp -> op == U_ADD )
 	(void) Do_UDelChars ( text );
       else {
@@ -676,5 +671,5 @@ static void Do_UReplace ( text, type, ol
     int old_line, old_pos;
 {
-    
+
     int newpos, modif = False;
     char *start, *end, *tmp;
@@ -682,13 +677,13 @@ static void Do_UReplace ( text, type, ol
     char *str_old = current_u -> str_new;
     char *str_new = current_u -> str_old;
-    
+
 #ifdef U_TRACE
     (void) fprintf ( stderr, "Do_UReplace\n" );
 #endif /* U_TRACE */
-    
+
     TextCursorOff ( text );
     SetTextModif ( text );
     MoveHole ( text -> buf , current_u -> pos );
-    
+
     start = (char *) RightBuf ( text -> buf );
     end = (char *) BottomBuf ( text -> buf );
@@ -696,5 +691,5 @@ static void Do_UReplace ( text, type, ol
     while ( (newpos=BmSearch( start, str_old,  end - start, 1 )) != -1 ) {
 	/* On se place a la fin du mot */
-	(void) MoveHole ( text -> buf, newpos + strlen (str_old)); 
+	(void) MoveHole ( text -> buf, newpos + strlen (str_old));
 	DeleteNchar ( text -> buf, strlen ( str_old) );
 	InsertNchar ( text -> buf, str_new, strlen ( str_new));
@@ -703,5 +698,5 @@ static void Do_UReplace ( text, type, ol
 	if ( text -> current_ce != 0 )
 	  (void) UpdateColorList ( text, strlen(str_new)-strlen(str_old));
-  
+
 	modif = True;
 	start = (char *) RightBuf ( text -> buf ); /* Position courante */
@@ -715,5 +710,5 @@ static void Do_UReplace ( text, type, ol
     HoleToLeft ( text -> buf );
     text -> no_current_line = 1;
-    
+
     if ( type == U_REP ) {
 #ifdef U_TRACE
@@ -737,5 +732,5 @@ static void Do_UReplace ( text, type, ol
 	SetTextModif ( text );
     }
-    
+
     tmp = (char *) malloc ( (unsigned) strlen ( current_u  -> str_old ) + 1 );
 #ifdef U_TRACE
@@ -766,5 +761,5 @@ static void Do_UAddChars ( text )
     (void) fprintf ( stderr, "Do_UAddChars \n" );
 #endif /* U_TRACE */
-    
+
     TextCursorOff ( text );
     SetTextModif ( text );
@@ -809,12 +804,12 @@ static void Do_UDelChars ( text )
 {
     int lines;
-    Undo *current_u = GetCurrentUndo ( text );	
+    Undo *current_u = GetCurrentUndo ( text );
 #ifdef U_TRACE
     (void) fprintf ( stderr, "Do_UDelChars\n" );
 #endif /* U_TRACE */
-    
+
     TextCursorOff ( text );
     ClipOn ( text, 0 );
-    
+
     MoveHole ( text -> buf, current_u -> pos );
     lines = GetNewLine (current_u -> buf, current_u -> size );
@@ -839,5 +834,5 @@ static void Do_UDelChars ( text )
 	SetLinesTable ( text );
 	RefreshPage ( text );
-	(void) MoveScrollBar ( dpy, text -> swin, 
+	(void) MoveScrollBar ( dpy, text -> swin,
 			      CURRENT, text -> no_current_line - text -> n1 - 1 );
 	RefreshScrollBar ( dpy, text -> swin );
@@ -870,5 +865,5 @@ static void Do_UDelOneChar ( text )
     (void) fprintf ( stderr, "Do_UDelOneChar\n" );
 #endif /* U_TRACE */
-    
+
     if ((current_u -> type == U_INSERT)
 	&& (current_u -> c == '\n')) {
@@ -896,11 +891,11 @@ static void Do_UDelOneChar ( text )
     if ( (current_u -> c == '\n')
 	&& (current_u -> type != U_INSERT) ) {
-	
+
 #ifdef U_TRACE
 	(void) fprintf ( stderr, "Do_UDelOneChar : c : return\n" );
 #endif /* U_TRACE */
-	
+
 	current_u -> current_line --;
-	current_u -> pos = 	
+	current_u -> pos =
 	  1 + GetNcFromLeft ( text -> buf );
     }
@@ -923,5 +918,5 @@ static void Do_UAddOneChar ( text )
     (void) fprintf ( stderr, "Do_UAddOneChar\n" );
 #endif /* U_TRACE */
-    
+
     MoveHole ( text -> buf, current_u -> pos -1);
     switch ( current_u -> c ) {
@@ -954,5 +949,5 @@ static void Do_UAddOneChar ( text )
 #endif /* U_TRACE */
       }
-      
+
       break;
     case '\t':
@@ -976,5 +971,5 @@ static void Do_UAddOneChar ( text )
       (void) fprintf ( stderr, "Do_UAddOneChar : Default\n" );
 #endif /* U_TRACE */
-      
+
       text -> u_todo = False;
       f_impc ( text, (int) current_u -> c );
@@ -1006,5 +1001,5 @@ void DoUndoUndo ( text )
 	(void) fprintf ( stderr, "DoUndoUndo : index (null)\n" );
 #endif /* U_TRACE */
-	
+
 	klaxon ();
 	return;
--- warn_box.c	2006-11-16 12:00:13.000000000 -0500
+++ warn_box.c	2014-12-26 00:30:46.000000000 -0500
@@ -303,5 +303,5 @@ static void UpdateWarningTitle ()
 */
 void DisplayWMessage ( mess, from, separator )
-    char *mess, *from;
+    const char *mess, *from;
     int separator;
 {
--- warn_box.h	1997-01-24 09:54:53.000000000 -0500
+++ warn_box.h	2014-12-26 00:31:11.000000000 -0500
@@ -76,8 +76,8 @@ typedef struct {
 FCT (int, ButtonWarningBox, (XButtonEvent *ev) );
 FCT (void, ConfigWarningBox, (int width, int height) );
-FCT (void, DisplayWMessage, (char *mess, char *from, int separator) );
+FCT (void, DisplayWMessage, (const char *mess, const char *from, int separator) );
 FCT (int, ExposeWarningBox , (XEvent *ev) );
-FCT (void, InitWarningBox, () );
-FCT (void, UnmapWarningBox, () );
+FCT (void, InitWarningBox, (void) );
+FCT (void, UnmapWarningBox, (void) );
 
 #endif /* _WARN_BOX_H_ */
--- xcoral.c	2005-12-16 07:49:26.000000000 -0500
+++ xcoral.c	2014-12-27 22:41:38.000000000 -0500
@@ -40,4 +40,5 @@
 
 #include <stdio.h>
+#include <stdlib.h>
 #include <signal.h>
 #include <X11/Xlib.h>
@@ -45,4 +46,5 @@
 #include <X11/Xutil.h>
 #include <X11/keysym.h>
+#include <X11/Xresource.h>
 #include <sys/param.h>
 
@@ -67,4 +69,7 @@
 #include "new_window.h"
 #include "tool_bar.h"
+#include "tbox.h"
+#include "color_area.h"
+#include "Smac/smac.h"
 
 #if HAVE_STRING_H
@@ -72,5 +77,5 @@
 #  if !HAVE_BZERO
 extern FCT (void, bzero, (char *dst, int len) );
-extern FCT (void, bcopy, (char *src, char *dst, int len) );
+extern FCT (void, bcopy, (const char *src, char *dst, int len) );
 #  endif
 #else
@@ -86,6 +91,4 @@ FCT (static RETSIGTYPE, contHandler, () 
 FCT (static RETSIGTYPE, stopHandler, () );
 
-extern init_smac();
-
 /*
  **	Initialise les resources, les menus, les bouttons etc...
@@ -93,4 +96,5 @@ extern init_smac();
  **	la boucle d'evenements.
  */
+int
 main ( argc, argv ) 
     int argc;
@@ -175,5 +179,9 @@ main ( argc, argv ) 
   SetBrowserMode ( (Mode *) GetMode ("C++mode") );
   SetBrowserDir ( (char *) pathname );
+#ifdef RUNTIMECHECK
   init_smac(1024, 18);
+#else
+  init_smac(1024);
+#endif
   InitIconPixmap ();
   InitSelection (dpy,GetOpColor ( OP_TEXT_FG ), GetOpColor ( OP_TEXT_BG ));
@@ -195,6 +203,5 @@ main ( argc, argv ) 
     xcoralrc = (char *) getenv ("XCORALRC");
     if (!xcoralrc) {
-      (void) sprintf ( tmp, (char *) getenv ( "HOME" ) );
-      (void) strcat ( tmp, "/.xcoralrc" );
+      (void) sprintf (tmp, "%s/.xcoralrc", getenv("HOME"));
     }
     else 
@@ -204,24 +211,22 @@ main ( argc, argv ) 
       /* pas de xcoralrc defini, ca craint */
       /* On copie celui qui est dans SmacLib */
-      (void) sprintf (tmp, "cp %s/xcoralrc.lf %s/.xcoralrc\n",
-		      XCORAL_LIB_DIR,(char *)getenv ("HOME"));
+      (void) sprintf (tmp, "cp -p %s/xcoralrc.lf %s/.xcoralrc\n",
+		      XCORAL_LIB_DIR, getenv ("HOME"));
       system(tmp);
-      (void) sprintf (tmp, (char *) getenv ("HOME"));
-      (void) strcat (tmp, "/.xcoralrc");
+      (void) sprintf (tmp, "%s/.xcoralrc", getenv("HOME"));
     }
     else {
       /* On verifie que la version est correcte */
-      if ((fd = fopen((char *)tmp,"r"))!=0){
+      if ((fd = fopen(tmp, "r"))!=0){
 	fgets(pp,8,fd);
-	if (strncmp((char *)(pp+3),CURRENT_VERSION,4)!=0){
+	if (strncmp(pp + 3, CURRENT_VERSION, 4) != 0){
 	  /* .xcoralrc ne correspond pas a la version courante. Copie */
-	  (void) sprintf(pp,"%s/.xcoralrc.old",(char *)getenv ("HOME"));
+	  (void) sprintf(pp, "%s/.xcoralrc.old", getenv ("HOME"));
 	  rename (tmp,pp);
 	  /* On copie celui qui est dans SmacLib */
-	  (void) sprintf (tmp, "cp %s/xcoralrc.lf %s/.xcoralrc\n",
-			  XCORAL_LIB_DIR,(char *)getenv ("HOME"));
+	  (void) sprintf (tmp, "cp -p %s/xcoralrc.lf %s/.xcoralrc\n",
+			  XCORAL_LIB_DIR, getenv ("HOME"));
 	  system(tmp);
-	  (void) sprintf (tmp, (char *) getenv ("HOME"));
-	  (void) strcat (tmp, "/.xcoralrc");
+	  (void) sprintf (tmp, "%s/.xcoralrc", getenv ("HOME"));
 	  (void) fprintf (stderr,"Your .xcoralrc file is obsolete so it has been moved as .xcoralrc.old\n");
 	  (void) fprintf (stderr,"A new .xcoralrc file has been created in your home directory\n");
@@ -301,6 +306,6 @@ main ( argc, argv ) 
 
   WaitForEvent ();
-  
   /*NOTREACHED*/
+  return 0;
 }
 
--- xcoral.h	2008-04-02 14:50:44.000000000 -0400
+++ xcoral.h	2014-12-26 00:45:37.000000000 -0500
@@ -49,5 +49,5 @@
  *	La structure associe a chaque fenetre d'edition.
  */
-typedef struct {
+struct EdWin {
 	Window		w_frame;	/* La fenetre mere */
 	int		width, height;	/* Geometrie */
@@ -60,5 +60,6 @@ typedef struct {
 	XSizeHints	*shints;	/* Les options */
 	ToolBar         *tool_bar;      /* la tool bar */
-} EdWin;
+};
+typedef struct EdWin EdWin;
 
 extern Display	*dpy;		/* Le display */
@@ -67,6 +68,6 @@ extern EdWin	*TWin [];		/* La table de f
 extern XContext	EdContext;	/* Le contexte courant */
 
-extern char 	*menu_names [];
-extern char 	**item_names [];	
+extern const char 	*menu_names [];
+extern const char 	**item_names [];	
 extern void		(**func_names []) ();	/* Callback */
 
--- cb_names.c	2001-10-18 07:25:18.000000000 -0400
+++ cb_names.c	2014-12-28 22:31:56.000000000 -0500
@@ -59,9 +59,9 @@
 #include "tbox.h"
 
-char *menu_names[] = { 
+const char *menu_names[] = { 
 	"File", "Window", "Edit", "Modes", "Search", "Region", "Font", "Misc", 0
 };
 
-static char *file_menu [] = {
+static const char *file_menu [] = {
 	"New file        ^x k",
 	"Read file       ^x^f",
@@ -75,5 +75,5 @@
 };
 			
-static char *window_menu [] = {
+static const char *window_menu [] = {
 	"New text window     ^x n",
 	"Delete text window  ^x^c",
@@ -85,5 +85,5 @@
 };
 
-static char *edit_menu [] = {
+static const char *edit_menu [] = {
   "Undo           ^u",
   "Redo           ^t",
@@ -94,5 +94,5 @@
 };
 
-static char *mode_menu [] = {
+static const char *mode_menu [] = {
 	"Select default mode",
 	"Select C mode",
@@ -113,5 +113,5 @@
 };
 			
-static char *search_menu [] = { 
+static const char *search_menu [] = { 
 	"Forward search        ^s",
 	"Backward search       ^r",
@@ -125,5 +125,5 @@
 };
 
-static char *mark_menu [] = {
+static const char *mark_menu [] = {
 	"Set mark              ^space",
 	"Goto the mark           ^x m",
@@ -141,20 +141,5 @@
 };
 
-static char *version_menu [] = {
-        "Initialize version",
-        "Check in",
-	"Check out locked",
-	"Check out unlocked",
-	"Check in and out locked",
-	"Check in and out unlocked",
-	"Lock revision",
-	"Unlock revision",
-	"Display diff",
-	"Display log",
-	"Display repository",
-	0
-};
-
-static char *font_menu [] = { 
+static const char *font_menu [] = { 
 	"Courier bold 10",
 	"Courier bold 12",
@@ -175,5 +160,5 @@
 };
 
-static char *font_names [] = {
+static const char *font_names [] = {
         "-adobe-courier-bold-r-normal--10-100-75-75-m-60-iso8859-1",  
         "-adobe-courier-bold-r-normal--12-120-75-75-m-70-iso8859-1",
@@ -193,5 +178,5 @@
 };
 
-static char *misc_menu [] = {
+static const char *misc_menu [] = {
   "Programming util... ",
   "Rcs commands...     ",
@@ -208,5 +193,5 @@
 };
 
-char **item_names [] = {
+const char **item_names [] = {
 	file_menu,
 	window_menu,
@@ -298,19 +283,4 @@
 };
 
-static void (*f_version []) () = {
-        CV_Initialize,
-	CV_CheckIn,
-	CV_CheckOutLocked,
-	CV_CheckOutUnlocked,
-	CV_CheckInAndOutLocked,
-	CV_CheckInAndOutUnlocked,
-	CV_LockRevision,
-	CV_UnlockRevision,
-	CV_ListDiff,
-	CV_ListLog,
-	CV_ListRepository,
-	0
-};
-
 static void (*f_font []) () = { 
 	0,0,0,0,0,0,0,0,0,0,0,0,0,0
